//BilderPreflight_201d.js
// 01.04.10 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Prfung der geladenen Bilder

// vorsichtshalber die Dialoge einschalten
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Ein Dokument ffnen.", "Achtung");
	exit();
}

//--------------------------------------------
// ***** die Variablen vorbereiten *****
//--------------------------------------------
// aktives Dokument notieren
var curDoc = app.documents[0];
ctr = 0;

// den Namen des Dokuments speichern
var docName = curDoc.name;

// die Problem-Listen vorbereiten
var minList  = new Array();
var maxList  = new Array();
var modiList = new Array();
var missList = new Array();
var rgbList  = new Array();

// den Handler aufrufen, welcher die gespeicherten Vorgaben einliest
var checkDef = getPrefs();
// die Werte ausziehen
if (checkDef != "") {
	var defVal = checkDef.split("\n");
	var minPPI = defVal[0]*1;
	var maxPPI = defVal[1]*1;
	var rck = defVal[2];
	if (rck == "true") { rck = true; } else { rck = false; }
	var mck = defVal[3];
	if (mck == "true") { mck = true; } else { mck = false; }
	var fck = defVal[4];
	if (fck == "true") { fck = true; } else { fck = false; }
}
else {
	var minPPI = 200;
	var maxPPI = 0;
	var rck = false;
	var mck = false;
	var fck = false;
}

// dem Anwender den Dialog zeigen 
var checkDef = askUser();

// den Handler aufrufen, welcher das Ergebnis in eine Datei schreibt
writeResult(checkDef);

// den Handler aufrufen, welcher die geladenen Bilder untersucht
checkImages();

// der Handler, welcher die Informationen vorbereitet
function getPrefs() {
	var checkDef = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/checkImg.txt");
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			checkDef = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return checkDef;
}

// den Anwender auffordern, die Werte einzugeben
function askUser() {
	// Dialoge, welche eventuell im Speicher geblieben sind, lschen
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	// den Dialog vorbereiten
	var aDialog = app.dialogs.add({name:"Bilder-Preflight", canCancel:true});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Die Wahl treffen"});
				staticTexts.add({staticLabel:" "});
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Minimale Auflsung", minWidth:120});
							var minPPIval = integerEditboxes.add({editValue:minPPI, minimumValue:1, maximumValue:9999, minWidth:48});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Maximale Auflsung", minWidth:120});
							var maxPPIval = integerEditboxes.add({editValue:maxPPI, minWidth:48});
						}
					}
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:2});
				var getRGBbox = checkboxControls.add({staticLabel:"RGB-Bilder finden", checkedState:rck});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:2});
				var getModbox = checkboxControls.add({staticLabel:"modifizierte Bilder rapportieren", checkedState:mck});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:2});
				var getMssbox = checkboxControls.add({staticLabel:"fehlende Bilder rapportieren", checkedState:fck});
			}
		}
		with (dialogColumns.add()) {
			staticTexts.add({staticLabel:"", minWidth:4});
		}
	}
	
	// den Dialog anzeigen
	if (aDialog.show() == true) {
		// die minimale Auflsung
		minPPI = minPPIval.editValue;
		// die maximale Auflsung
		maxPPI = maxPPIval.editValue;
		// RGB-Bilder finden
		rck = getRGBbox.checkedState;
		// modifizierte Bilder rapportieren
		mck = getModbox.checkedState;
		// fehlende Bilder rapportieren
		fck = getMssbox.checkedState;
		// den Dialog aus dem Speicher entfernen
		aDialog.destroy();
		// das Ergebnis zum Speichern vorbereiten
		var checkDef = minPPI + "\n" + maxPPI + "\n" + rck + "\n" + mck + "\n" + fck;
	}
	else {
		aDialog.destroy();
		exit();
	}
	return checkDef;
}

// das Ergebnis in eine Datei schreiben
function writeResult(checkDef) {
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/checkImg.txt");
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(checkDef);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// die Hauptfunktion
function checkImages() {
	// die Bildpfade auflisten
	var allImages = curDoc.links;
	// eine Schleife durch die Bilder
	// bei einem Problem, den Namen des Bildes an die entsprechende Liste hngen
	for (var i=0; i<allImages.length; i++) {
		if (allImages[i].needed == true) {
			var curImg = allImages[i];
			// den Status des Bildes speichern
			imgStatus = curImg.status;
			if (imgStatus == 1819242340){ // = gendertes Bild
				if (mck) {
					modiList.push(curImg.name);
					ctr++;
				}
			}
			else if (imgStatus == 1819109747) { // = fehlendes Bild
				if (fck) {
					missList.push(curImg.name);
					ctr++;
				}
			}
			else {
				if (imgStatus != 1282237028) { // = eingebettetes Bild
					if (minPPI > 0 || maxPPI > 0) {
						try {
							var imgPPI = curImg.parent.effectivePpi;
							if (minPPI > 0) {
								for (var p=0; p<2; p++) {
									if (imgPPI[p] < minPPI) {
										minList.push(curImg.name);
										ctr++;
										break;
									}
								}
							}
							if (maxPPI > 0) {
								for (var p=0; p<2; p++) {
									if (imgPPI[p] > maxPPI) {
										maxList.push(curImg.name);
										ctr++;
										break;
									}
								}
							}
						}
						catch (e) {
						}
					}
				}
				if (rck) {
					var colorSpace = curImg.parent.space;
					if (colorSpace == "RGB" || colorSpace == "RVB") {
						rgbList.push(curImg.name);
						ctr++;
					}
				}
			}
		}
	}
}

//---------------------------------------------
// ***** die Textketten vorbereiten *****
//---------------------------------------------
var nMin = minList.length;
if (nMin > 0) {
	var minString = minList.join("\n");
}

var nMax = maxList.length;
if (nMax > 0) {
	var maxString = maxList.join("\n");
}

var nMods = modiList.length;
if (nMods > 0) {
	var modiString = modiList.join("\n");
}

var nMiss = missList.length;
if (nMiss > 0) {
	var missString = missList.join("\n");
}

var nRGB = rgbList.length;
if (nRGB > 0) {
	var rgbString = rgbList.join("\n");
}

//---------------------------------------------
// ***** den Wert des Zhlers prfen *****
//---------------------------------------------
if (ctr>0) {
	// wenn nur ein Problem, dann einen Dialog zweigen
	if (ctr == 1) {
		if (nMin == 1) {
			alert ("Die effektive Auflsung dieses Bildes ist geringer als "+ minPPI + " ppi:\n\n" + minString, "Achtung");
		}
		if (nMax == 1) {
			alert ("Die effektive Auflsung dieses Bildes ist grsser als "+ maxPPI + " ppi:\n\n" + maxString, "Achtung");
		}
		else if (nMods == 1) {
			alert ("Dieses Bild ist modifiziert:\n\n" + modiString, "Achtung");
		}
		else if (nMiss == 1) {
			alert ("Dieses Bild fehlt:\n\n" + missString, "Achtung");
		}
		else if (nRGB == 1) {
			alert ("Dieses Bild ist in RGB:\n\n" + rgbString, "Achtung");
		}
	}
	// bei mehreren Problemen warnen, dann ein Rapport-Dokument erzeugen
	else {
		alert ("Es hat Problem-Bilder.\n\nSiehe Rapport.", "Achtung");
		var repDoc = app.documents.add();
		if (repDoc.documentPreferences.pageWidth != 210) {
			repDoc.documentPreferences.pageWidth = 210;
		}
		if (repDoc.documentPreferences.pageHeight != 297) {
			repDoc.documentPreferences.pageHeight = 297;
		}
		repDoc.pages.item(0).marginPreferences.top = 15;
		repDoc.pages.item(0).marginPreferences.left = 25;
		repDoc.pages.item(0).marginPreferences.bottom = 15;
		repDoc.pages.item(0).marginPreferences.right = 15;
		var repFrame = repDoc.textFrames.add();
		repFrame.geometricBounds = [15,25,282,195];
		
		var repString = "Dokument \"" + docName + "\", Probleme:\r\r";
		
		if (nMin == 1) {
			repString = repString + "Die effektive Auflsung dieses Bildes ist geringer als "+ minPPI + " ppi:\n" + minString + "\r\r";
		}
		else if (nMin > 1) {
			repString = repString + "Die effektive Auflsung dieser Bilder ist geringer als "+ minPPI + " ppi:\n" + minString + "\r\r";
		}
		if (nMax == 1) {
			repString = repString + "Die effektive Auflsung dieses Bildes ist grsser als "+ maxPPI + " ppi:\n" + maxString + "\r\r";
		}
		else if (nMax > 1) {
			repString = repString + "Die effektive Auflsung dieser Bilder ist grsser als "+ maxPPI + " ppi:\n" + maxString + "\r\r";
		}
		if (nMods == 1) {
			repString = repString + "Dieses Bild ist modifiziert:\n" + modiString + "\r\r";
		}
		else if (nMods > 1) {
			repString = repString + "Diese Bilder sind modifiziert:\n" + modiString + "\r\r";
		}
		if (nMiss == 1) {
			repString = repString + "Dieses Bild fehlt:\n" + missString + "\r\r";
		}
		else if (nMiss > 1) {
			repString = repString + "Diese Bilder fehlen:\n" + missString + "\r\r";
		}
		if (nRGB == 1) {
			repString = repString + "Dieses Bild ist in RGB:\n" + rgbString + "\r\r";
		}
		else if (nRGB > 1) {
			repString = repString + "Diese Bilder sind in RGB:\n" + rgbString + "\r\r";
		}
		repFrame.contents = repString;
	}
}
else {
	alert ("Keine Problem-Bilder.", " ");
}